<?
// .xml configuracio beolvaso (es a beolvasast segito) rutinok
// config.php re'sze

if (version_compare(PHP_VERSION, '5', '>='))
  require_once('domxml-php4-to-php5.php'); //Load the PHP5 converter

function config_checklogin($passwordarray) {
  #if (!array_key_exists($passwordarray[$_SERVER["PHP_AUTH_USER"]])
  if (isset($_SERVER["PHP_AUTH_USER"]) &&
    ($passwordarray[$_SERVER["PHP_AUTH_USER"]] === sha1($_SERVER["PHP_AUTH_PW"]) ||
    (($_SERVER["PHP_AUTH_PW"] === '') && ($passwordarray[$_SERVER["PHP_AUTH_USER"]] === '')))) {
  } else {
    header("WWW-Authenticate: Basic realm=\"oai configuration\"");
    header("HTTP/1.0 401 Unauthorized");
    print "Hibas felhasznalonev vagy jelszo\n";
    exit;
  }
}

if(!function_exists('getSubelementContent')) { 
  function getSubelementContent($DomElement, $tagname, $num = 0) {
    if($DomElement !== NULL) {
      $x = $DomElement->get_elements_by_tagname($tagname);
      if(count($x) > $num) {
        return $x[$num]->get_content();
      }
      return NULL;
    }
  }
}

if (!function_exists('getConnectIPs')) { 
  function getConnectIPs($dom, $tagname) {
    $allow = array();
    $domallow = $dom->get_elements_by_tagname($tagname);
    if (array_key_exists(0, $domallow)) {
      $domHCip = $domallow[0]->child_nodes();
      foreach($domHCip as $zendfix => $value) {
        if ($value->tagname === "ip") {
          $allow[$value->get_content()] = $value->get_content();
        }
      }
    }
    return $allow;
  }
}

function loadConfig($XMLconfigfile, $fatal = TRUE) {
  if(!$dom = domxml_open_file($XMLconfigfile)) {
    print "Hiba a konfiguracio betoltese kozben( " . $XMLconfigfile . " )\n";
    if ($fatal) {
      exit;
    } else {
      return;
    }
  }

  $cfg = Array();

  // Database
  $domdatabase = $dom->get_elements_by_tagname("database");
  if(count($domdatabase) > 0) {
    $cfg["db.type"] = getSubelementContent($domdatabase[0], "type");
    $cfg["db.host"] = getSubelementContent($domdatabase[0], "host");
    $cfg["db.username"] = getSubelementContent($domdatabase[0], "username");
    $cfg["db.password"] = getSubelementContent($domdatabase[0], "password");
    $cfg["db.database"] = getSubelementContent($domdatabase[0], "database");
    $cfg["db.table"] = getSubelementContent($domdatabase[0], "table");
    if(getSubelementContent($domdatabase[0], "warn") == "1") {
      $cfg["db.warn"] = 1;
    } else {
      $cfg["db.warn"] = 0;
    }
  }

  // Settings / Identification
  $domsettings = $dom->get_elements_by_tagname("settings");
  if(count($domsettings) > 0) {
    $cfg["sett.res.size"] = getSubelementContent($domsettings[0], "resumptionSize");
    $cfg["sett.res.exp"] = getSubelementContent($domsettings[0], "resumptionExpirationHours");
  }

  $domidentification = $dom->get_elements_by_tagname("identification");
  if(count($domidentification) > 0) {
    $cfg["id.repositoryName"] = getSubelementContent($domidentification[0], "repositoryName");
    $cfg["id.repositoryId"] = getSubelementContent($domidentification[0], "repositoryId");
    $cfg["id.baseURL"] = getSubelementContent($domidentification[0], "baseURL");
    $cfg["id.protocolVersion"] = getSubelementContent($domidentification[0], "protocolVersion");
    $cfg["id.del"] = getSubelementContent($domidentification[0], "deletedRecord");
    $cfg["id.email"] = getSubelementContent($domidentification[0], "adminEmail");
    $i = 0;
    $cfg["id.friends"] = array();
    while($tmp = getSubelementContent($domidentification[0], "friends", $i)) {
      $cfg["id.friends"][] = $tmp;
      $i++;
    }
  }

  // Manager hozzfrs
  $dommanager = $dom->get_elements_by_tagname("manager");
  if(count($dommanager) > 0) {
    $cfg["man.user"] = getSubelementContent($dommanager[0], "user");
    $cfg["man.passwordHash"] = getSubelementContent($dommanager[0], "passwordHash");
  }

  // Vltozsjelents
  $dommodify = $dom->get_elements_by_tagname("modificationReport");
  if(count($dommodify) > 0) {
    $cfg["mod.url"] = getSubelementContent($dommodify[0], "url");
    $cfg["mod.idParParam"] = getSubelementContent($dommodify[0], "identifierParamName");
    $cfg["mod.schemaParName"] = getSubelementContent($dommodify[0], "schemaListParamName");
  }

  // Metaadat formtumok.
  $dommetadataFormats = $dom->get_elements_by_tagname("metadataFormats");
  if (count($dommetadataFormats) > 0) {
    $domFormats = $dommetadataFormats[0]->child_nodes();
    $cfg["meta"] = array();
    foreach($domFormats as $zendfix => $value) {
      if ($value->tagname === "format") {
        $format = Array();

        $format["name"] = $value->get_attribute("name");
        $format["rootElementName"] = getSubelementContent($value, "rootElementName");
        $format["schema"] = getSubelementContent($value, "schema");
        $format["namespace"] = getSubelementContent($value, "namespace");
        $format["csvseparator"] = getSubelementContent($value, "csvseparator");

        $domcsvmap = $value->child_nodes();
        $csv = Array();
        foreach($domcsvmap as $zendfix2 => $csvmap) {
          if ($csvmap->tagname === "csvmap") {
            $i = $csvmap->get_attribute("column");
            $csv[$i]["tag"] = $csvmap->get_attribute("tag");
            $csv[$i]["attribute"] = $csvmap->get_attribute("attribute");
          }
        }
        $format["csv"] = $csv;

        $cfg["format"][] = $format;
      }
    }
  }

  $cfg["ip.harvester"] = implode(",", getConnectIPs($dom, "allowHarvesterConnect"));
  $cfg["ip.manager"] = implode(",", getConnectIPs($dom, "allowManagerConnect"));

  return $cfg;
}

function mergeArrays(&$a, $b) {
  foreach($b as $key => $val) {
    if(is_array($val)) {
      if(!is_array($a[$key])) {
        $a[$key] = Array();
      }
      mergeArrays(&$a[$key], $val);
    } else if($val !== NULL) {
      $a[$key] = $val;
    }
  }
}

function gpc_stripslashes($data) {
  if (get_magic_quotes_gpc()) {
    return stripslashes($data);
  } else {
    return $data;
  }
}

?>
